////////////////////////////////////////////////////////////////////////////////
// Filename: Protocol.hh                                                      //
// Purpose.: defines the class 'Protocol'                                     //
////////////////////////////////////////////////////////////////////////////////
// Author: Markus Keidl                                                       //
// Theme.: 2                                                                  //
// Group.: 5 (Gerald Anleitner, Stefan Seltzsam, Markus Keidl                 //
//                                                                            //
// Date of Creation: 21.05.1996        Date of last change: 13.07.1996        //
////////////////////////////////////////////////////////////////////////////////

#ifndef _PROTOCOL_HH
#define _PROTOCOL_HH

#include <String.h>
#include <DLList.h>
#include "Input_Stream.hh"
#include "Input_Atom.hh"

class Protocol
{
  friend ostream& operator<<(ostream& s, Protocol prot);

public:
  // constructors and destructor
  Protocol(const Protocol& rhs);
  Protocol(Input_Stream& s);
  ~Protocol();		 

  String& get_token();		// get the scanned token
  int get_length();		// get the length of the scanned stream
  void clear();			// erase all values of Protocol except input_stream
  Input_Stream& get_Input_Stream() const;
				// get Input_Stream
  Input_Stream get_scanned_stream() const;
				// get the scanned Input_Stream
  Input_Stream get_rest_stream() const;
				// get the rest of the Input_Stream
  void add_hit(const String& rec_token);
				// add hit with token

private:
  Protocol();			// default constructor  

  String token;
  int length;
  Pix position;
  Input_Stream& input_stream;
};

#endif
